import numpy as np
from scipy.special import j0, j1, jv

def integrandLR(x, n, Fz, g0, g1, R, d, ABCD, k11,k12,k01,k02,c11,c12,c01,c02):
    rho1 = x[:,0]
    phi1 = x[:,1]
    z1   = x[:,2]
    rho2 = x[:,3]
    phi2 = x[:,4]
    z2   = x[:,5]
    [A, B, C, D] = ABCD
    y = (4*np.power(d,2)*np.power(np.pi,2)*np.power(R,4)*rho1*rho2*np.conjugate((((np.exp(2*1j*(-1 + Fz)*phi1*np.pi)*g1*n*np.sqrt(2/np.pi)*(C*jv(1 + Fz,k01*R*rho1) + D*jv(1 + Fz,k02*R*rho1) + A*c11*jv(1 + Fz,k11*R*rho1) + B*c12*jv(1 + Fz,k12*R*rho1))*np.power(np.cos((np.pi*(-d/2. + d*z1))/d),2)*(-np.cos(2*phi1*np.pi) + np.complex(0,1)*np.sin(2*phi1*np.pi)))/d + (np.exp(2*1j*(1 + Fz)*phi1*np.pi)*g1*n*np.sqrt(2/np.pi)*(C*jv(-1 + Fz,k01*R*rho1) + D*jv(-1 + Fz,k02*R*rho1) - A*c11*jv(-1 + Fz,k11*R*rho1) - B*c12*jv(-1 + Fz,k12*R*rho1))*np.power(np.cos((np.pi*(-d/2. + d*z1))/d),2)*(np.cos(2*phi1*np.pi) + np.complex(0,1)*np.sin(2*phi1*np.pi)))/d)/np.sqrt(2) + (R*rho1*((np.exp(2*1j*(-1 + Fz)*phi1*np.pi)*g1*n*np.sqrt(2/np.pi)*((C*k01*(jv(Fz,k01*R*rho1) - jv(2 + Fz,k01*R*rho1)))/2. + (D*k02*(jv(Fz,k02*R*rho1) - jv(2 + Fz,k02*R*rho1)))/2. + (A*c11*k11*(jv(Fz,k11*R*rho1) - jv(2 + Fz,k11*R*rho1)))/2. + (B*c12*k12*(jv(Fz,k12*R*rho1) - jv(2 + Fz,k12*R*rho1)))/2.)*np.power(np.cos((np.pi*(-d/2. + d*z1))/d),2)*(-np.cos(2*phi1*np.pi) + np.complex(0,1)*np.sin(2*phi1*np.pi)))/d + (np.exp(2*1j*(1 + Fz)*phi1*np.pi)*g1*n*np.sqrt(2/np.pi)*((C*k01*(jv(-2 + Fz,k01*R*rho1) - jv(Fz,k01*R*rho1)))/2. + (D*k02*(jv(-2 + Fz,k02*R*rho1) - jv(Fz,k02*R*rho1)))/2. - (A*c11*k11*(jv(-2 + Fz,k11*R*rho1) - jv(Fz,k11*R*rho1)))/2. - (B*c12*k12*(jv(-2 + Fz,k12*R*rho1) - jv(Fz,k12*R*rho1)))/2.)*np.power(np.cos((np.pi*(-d/2. + d*z1))/d),2)*(np.cos(2*phi1*np.pi) + np.complex(0,1)*np.sin(2*phi1*np.pi)))/d))/np.sqrt(2))/(R*rho1) + ((np.complex(0,1)*np.exp(2*1j*(1 + Fz)*phi1*np.pi)*(1 + Fz)*g1*n*np.sqrt(2/np.pi)*(C*jv(-1 + Fz,k01*R*rho1) + D*jv(-1 + Fz,k02*R*rho1) - A*c11*jv(-1 + Fz,k11*R*rho1) - B*c12*jv(-1 + Fz,k12*R*rho1))*np.power(np.cos((np.pi*(-d/2. + d*z1))/d),2)*(np.complex(0,1)*np.cos(2*phi1*np.pi) - np.sin(2*phi1*np.pi)))/d + (np.exp(2*1j*(1 + Fz)*phi1*np.pi)*g1*n*np.sqrt(2/np.pi)*(C*jv(-1 + Fz,k01*R*rho1) + D*jv(-1 + Fz,k02*R*rho1) - A*c11*jv(-1 + Fz,k11*R*rho1) - B*c12*jv(-1 + Fz,k12*R*rho1))*np.power(np.cos((np.pi*(-d/2. + d*z1))/d),2)*(-np.cos(2*phi1*np.pi) - np.complex(0,1)*np.sin(2*phi1*np.pi)))/d + (np.exp(2*1j*(-1 + Fz)*phi1*np.pi)*g1*n*np.sqrt(2/np.pi)*(C*jv(1 + Fz,k01*R*rho1) + D*jv(1 + Fz,k02*R*rho1) + A*c11*jv(1 + Fz,k11*R*rho1) + B*c12*jv(1 + Fz,k12*R*rho1))*np.power(np.cos((np.pi*(-d/2. + d*z1))/d),2)*(np.cos(2*phi1*np.pi) - np.complex(0,1)*np.sin(2*phi1*np.pi)))/d + (np.complex(0,1)*np.exp(2*1j*(-1 + Fz)*phi1*np.pi)*(-1 + Fz)*g1*n*np.sqrt(2/np.pi)*(C*jv(1 + Fz,k01*R*rho1) + D*jv(1 + Fz,k02*R*rho1) + A*c11*jv(1 + Fz,k11*R*rho1) + B*c12*jv(1 + Fz,k12*R*rho1))*np.power(np.cos((np.pi*(-d/2. + d*z1))/d),2)*(np.complex(0,1)*np.cos(2*phi1*np.pi) + np.sin(2*phi1*np.pi)))/d)/(np.sqrt(2)*R*rho1) - (2*np.exp(2*1j*Fz*phi1*np.pi)*g0*n*np.sqrt(2*np.pi)*(A*jv(Fz,k11*R*rho1) + B*jv(Fz,k12*R*rho1))*np.cos((np.pi*(-d/2. + d*z1))/d)*np.sin((np.pi*(-d/2. + d*z1))/d))/np.power(d,2))*((((np.exp(2*1j*(-1 + Fz)*phi2*np.pi)*g1*n*np.sqrt(2/np.pi)*(C*jv(1 + Fz,k01*R*rho2) + D*jv(1 + Fz,k02*R*rho2) + A*c11*jv(1 + Fz,k11*R*rho2) + B*c12*jv(1 + Fz,k12*R*rho2))*np.power(np.cos((np.pi*(-d/2. + d*z2))/d),2)*(-np.cos(2*phi2*np.pi) + np.complex(0,1)*np.sin(2*phi2*np.pi)))/d + (np.exp(2*1j*(1 + Fz)*phi2*np.pi)*g1*n*np.sqrt(2/np.pi)*(C*jv(-1 + Fz,k01*R*rho2) + D*jv(-1 + Fz,k02*R*rho2) - A*c11*jv(-1 + Fz,k11*R*rho2) - B*c12*jv(-1 + Fz,k12*R*rho2))*np.power(np.cos((np.pi*(-d/2. + d*z2))/d),2)*(np.cos(2*phi2*np.pi) + np.complex(0,1)*np.sin(2*phi2*np.pi)))/d)/np.sqrt(2) + (R*rho2*((np.exp(2*1j*(-1 + Fz)*phi2*np.pi)*g1*n*np.sqrt(2/np.pi)*((C*k01*(jv(Fz,k01*R*rho2) - jv(2 + Fz,k01*R*rho2)))/2. + (D*k02*(jv(Fz,k02*R*rho2) - jv(2 + Fz,k02*R*rho2)))/2. + (A*c11*k11*(jv(Fz,k11*R*rho2) - jv(2 + Fz,k11*R*rho2)))/2. + (B*c12*k12*(jv(Fz,k12*R*rho2) - jv(2 + Fz,k12*R*rho2)))/2.)*np.power(np.cos((np.pi*(-d/2. + d*z2))/d),2)*(-np.cos(2*phi2*np.pi) + np.complex(0,1)*np.sin(2*phi2*np.pi)))/d + (np.exp(2*1j*(1 + Fz)*phi2*np.pi)*g1*n*np.sqrt(2/np.pi)*((C*k01*(jv(-2 + Fz,k01*R*rho2) - jv(Fz,k01*R*rho2)))/2. + (D*k02*(jv(-2 + Fz,k02*R*rho2) - jv(Fz,k02*R*rho2)))/2. - (A*c11*k11*(jv(-2 + Fz,k11*R*rho2) - jv(Fz,k11*R*rho2)))/2. - (B*c12*k12*(jv(-2 + Fz,k12*R*rho2) - jv(Fz,k12*R*rho2)))/2.)*np.power(np.cos((np.pi*(-d/2. + d*z2))/d),2)*(np.cos(2*phi2*np.pi) + np.complex(0,1)*np.sin(2*phi2*np.pi)))/d))/np.sqrt(2))/(R*rho2) + ((np.complex(0,1)*np.exp(2*1j*(1 + Fz)*phi2*np.pi)*(1 + Fz)*g1*n*np.sqrt(2/np.pi)*(C*jv(-1 + Fz,k01*R*rho2) + D*jv(-1 + Fz,k02*R*rho2) - A*c11*jv(-1 + Fz,k11*R*rho2) - B*c12*jv(-1 + Fz,k12*R*rho2))*np.power(np.cos((np.pi*(-d/2. + d*z2))/d),2)*(np.complex(0,1)*np.cos(2*phi2*np.pi) - np.sin(2*phi2*np.pi)))/d + (np.exp(2*1j*(1 + Fz)*phi2*np.pi)*g1*n*np.sqrt(2/np.pi)*(C*jv(-1 + Fz,k01*R*rho2) + D*jv(-1 + Fz,k02*R*rho2) - A*c11*jv(-1 + Fz,k11*R*rho2) - B*c12*jv(-1 + Fz,k12*R*rho2))*np.power(np.cos((np.pi*(-d/2. + d*z2))/d),2)*(-np.cos(2*phi2*np.pi) - np.complex(0,1)*np.sin(2*phi2*np.pi)))/d + (np.exp(2*1j*(-1 + Fz)*phi2*np.pi)*g1*n*np.sqrt(2/np.pi)*(C*jv(1 + Fz,k01*R*rho2) + D*jv(1 + Fz,k02*R*rho2) + A*c11*jv(1 + Fz,k11*R*rho2) + B*c12*jv(1 + Fz,k12*R*rho2))*np.power(np.cos((np.pi*(-d/2. + d*z2))/d),2)*(np.cos(2*phi2*np.pi) - np.complex(0,1)*np.sin(2*phi2*np.pi)))/d + (np.complex(0,1)*np.exp(2*1j*(-1 + Fz)*phi2*np.pi)*(-1 + Fz)*g1*n*np.sqrt(2/np.pi)*(C*jv(1 + Fz,k01*R*rho2) + D*jv(1 + Fz,k02*R*rho2) + A*c11*jv(1 + Fz,k11*R*rho2) + B*c12*jv(1 + Fz,k12*R*rho2))*np.power(np.cos((np.pi*(-d/2. + d*z2))/d),2)*(np.complex(0,1)*np.cos(2*phi2*np.pi) + np.sin(2*phi2*np.pi)))/d)/(np.sqrt(2)*R*rho2) - (2*np.exp(2*1j*Fz*phi2*np.pi)*g0*n*np.sqrt(2*np.pi)*(A*jv(Fz,k11*R*rho2) + B*jv(Fz,k12*R*rho2))*np.cos((np.pi*(-d/2. + d*z2))/d)*np.sin((np.pi*(-d/2. + d*z2))/d))/np.power(d,2)))/np.sqrt(np.power(d*z1 - d*z2,2) + np.power(R*rho1*np.cos(2*phi1*np.pi) - R*rho2*np.cos(2*phi2*np.pi),2) + np.power(R*rho1*np.sin(2*phi1*np.pi) - R*rho2*np.sin(2*phi2*np.pi),2))
    y_array = np.array([np.real(y), np.imag(y)]).transpose()
    y_array = y_array.copy(order='C')
    return y_array